loadJava("配置文件.java");
loadJava("HttpApi.java");
public static class TTSModel {
    private static final Map<String,String> ret_speakers=new LinkedHashMap();
    private static final Map<String,String> speakers=new LinkedHashMap();
    private static final String url1="https://v1.reecho.cn/api/tts/generate";
    private static final String url2="https://sfile.chatglm.cn/chatglm4";
    public static String Task(String id,int maxDepth,int currentDepth) {
        if(currentDepth>maxDepth) {
            return url2+"/db546237-3a76-4f57-ac88-53ab89cef4a8.aac";
        }
        try {
            String result=get(url1+"/"+id+"/?stream=true");
            JSONObject json=new JSONObject(result);
            Integer status=json.getInt("status");
            if(status==200) {
                String message=json.getString("message");
                JSONObject data=json.getJSONObject("data");
                JSONObject metadata=data.getJSONObject("metadata");
                if(metadata.has("audio")) {
                    return metadata.getString("audio");
                } else {
                    Thread.sleep(1500);
                    return Task(id,maxDepth,currentDepth+1);
                }
            }return;
        } catch(Exception e) {
            return url2+"/db546237-3a76-4f57-ac88-53ab89cef4a8.aac";
        }
    }
    public static Map<String,String> getCharacters() {
        try {
            String model=get("https://v1.reecho.cn/api/tts/voice");
            if(model.contains("Unauthorized")) {
                speakers.put("该账号未经授权无法使用","");
                return speakers;
            }
            JSONObject json=new JSONObject(model);
            Integer status=json.getInt("status");
            if(status==200) {
                String message=json.getString("message");
                JSONArray data=json.getJSONArray("data");
                if(data==null||data.length()==0) {
                    speakers.put("该账号未添加角色","");
                    return speakers;
                }
                for(int i=0; i<data.length(); i++)  {
                    JSONObject data_i=data.getJSONObject(i);
                    String id=data_i.getString("id");
                    String name=data_i.getString("name");
                    ret_speakers.put(name,id);
                }
                return ret_speakers;
            }
        } catch(Exception e) {
            speakers.put("错误，请重试","");
            return speakers;
        }
    }
    public static String performConvert(String text,String model) {
        if(text.length()>300) {
            text=text.substring(0,300);
        }
        if(model.equals("")) model="cd038be7-89c5-4c7d-b91a-e7157c1f16d5";
        try {
            String result=post(url1,"{\"model\":\"reecho-neural-voice-001\",\"contents\":[{\"voiceId\":\""+model+"\",\"text\":\""+text.replace("\n"," ")+"\"}],\"temperature\":"+temperature+",\"top_k\":"+top_k+",\"top_p\":"+top_p+",\"frames_to_keep\":5,\"enhance\":true,\"filter_top_k\":"+filter_top_k+",\"break_clone\":"+break_clone+"}");
            if(result.contains("Unauthorized")) {
                return url2+"/439df6c7-9fd4-4ac9-8513-e2c70ebe7d07.aac";
            }
            JSONObject json=new JSONObject(result);
            Integer status=json.getInt("status");
            String message=json.getString("message");
            if(status==200) {
                JSONObject data=json.getJSONObject("data");
                String id=data.getString("id");
                String userId=data.getString("userId");
                return Task(id,60,0);
            } else if(status==401) {
                return url2+"/4caf72c3-08dd-4bb1-9e46-b06bce560239.aac";
            }
        } catch(Exception e) {
            return url2+"/db546237-3a76-4f57-ac88-53ab89cef4a8.aac";
        }
    }
}